#!/usr/bin/env python
import sys,os
from data import * 
from default_line import *

types = ['primal', 'dual']
figdir = 'paper-figures'

solvers = [
		[5, '5-noshrink', 10, '10-noshrink'], #[5, 10, '12-noshrink', 12], 
		['10-cdn-shrinking3', '10-cdn-shrinking5', 10],
		[11, '7-noshrink'],
		[11, '7-noshrink'],
		#['11-cdn-shrinking3', '11-cdn-shrinking4', '11-cdn-shrinking5', '11-cdn-shrinking6', 11],
		['11-cdn-shrinking3', '11-cdn-shrinking5', 11],
		[11, 7],
		]

data_sets = [
		[E2006_scale_default_1, LE2006_scale_default_1, mydong_scale_default_1, kdd2010b_scale_default_1, MSD_scale_default_1],
		[E2006_scale_default_1, LE2006_scale_default_1, mydong_scale_default_1, kdd2010b_scale_default_1, MSD_scale_default_1],
		[E2006_default_2, LE2006_default_2, mydong_default_2, kdd2010b_default_2, MSD_default_2],
		[E2006_scale_default_2, LE2006_scale_default_2, mydong_scale_default_2, kdd2010b_scale_default_2, MSD_scale_default_2],
		[E2006_scale_default_2, LE2006_scale_default_2, mydong_scale_default_2, kdd2010b_scale_default_2, MSD_scale_default_2],
		[E2006_scale_lsmse_2, LE2006_scale_lsmse_2, mydong_scale_lsmse_2, kdd2010b_scale_lsmse_2, MSD_scale_lsmse_2],
		]
L = [1, 1, 2, 2, 2, 2]

names = [
	"-dcd-cdn", #"-figure3",
	"-figure6",
	"-figure4",
	"-figure5",
	"-figure6",
	"-reply",
]

show_lines = [
	False,
	True,
	True,
	True,
	True,
	True,
]

show_dual = [
	False,		
	False,		
	False,		
	False,		
	True,
	False,
]

rename_solver = [
		{5:'DCD-1-sh', '5-noshrink':'DCD-1', 10:'DCD-2-sh', '10-noshrink':'DCD-2'},
	{},
	{},
	{},
	{},
	{}
]

objlimits = [
		{
			MSD_scale_default_1: (10**-5, 1),
			E2006_scale_default_1: (10**-5, 1),
			LE2006_scale_default_1: (10**-8, 1),
			mydong_scale_default_1: (4*10**-3, 1),
			kdd2010b_scale_default_1: (10**-4, 1)},
		{
			MSD_scale_default_1: (10**-4, 1),
			E2006_scale_default_1: (10**-4, 1),
			LE2006_scale_default_1: (10**-6, 1),
			mydong_scale_default_1: (2*10**-3, 1),
			kdd2010b_scale_default_1: (10**-4, 1)},
		{
			MSD_default_2: (10**-2, 10**2),
			E2006_default_2: (10**-10, 1),
			LE2006_default_2: (10**-6, 10**6),
			mydong_default_2: (10**-6, 10),
			kdd2010b_default_2: (10**-4, 10)},
		{
			MSD_scale_default_2: (10**-9, 1),
			E2006_scale_default_2: (10**-10, 10**-1),
			LE2006_scale_default_2: (10**-9, 10),
			mydong_scale_default_2: (10**-8, 10),
			kdd2010b_scale_default_2: (10**-10, 10)},
		{
			MSD_scale_default_2: (10**-7, 1),
			E2006_scale_default_2: (10**-8, 1),
			LE2006_scale_default_2: (10**-7, 1),
			mydong_scale_default_2: (10**-8, 1),
			kdd2010b_scale_default_2: (10**-8, 1)},
		{},
		{}
		]

for data in data_sets:
	for d in data:
		for limits in objlimits:
			if d not in limits:
				limits[d] = None

note = ''
logdir = 'log'
shrink_cmp = False

def get_default_dcd_obj(a = None, b = None):
	return None
def get_default_dcd_err(a = None, b = None):
	return None
def get_default_dcd_cor(a = None, b = None):
	return None

if len(sys.argv) > 1:
	for arg in sys.argv[1:]:
		if arg[:5] == '-log=':
			logdir = arg[5:]
		elif arg == '-ns':
			note += '-noshrink'
		elif arg == '-cmpsh':
			shrink_cmp = True
		else:
			sys.stderr.write('ERROR: no option {0}.\n'.format(arg))
			sys.stderr.write('	-ns	no shrinking\n')
			sys.stderr.write('	-cmpsh	compare shrinking and no shrinking\n')
			exit(1)
print logdir

FILETYPE = ['png']

def existlog(log):
	if not os.path.exists(log):
		print('\t%s does not exist.' % log)
		return False
	else:
		return True

withoutlog = False
def getcoordinates(data, p, type, solver = None):
	global withoutlog
	global note
	withoutlog = False
	
	times, primals, primals2, accuracys, accuracys2 = {}, {}, {}, {}, {}

	for solver in solvers[p]:
		print('\t' + solver_labels[solver])

		times[solver], primals[solver], primals2[solver], accuracys[solver], accuracys2[solver] = [], [], [], [], []
		log = os.path.join(logdir,'L{0}-{1}-{2}{3}.log'.format(L[p], data.name, solver, note))
		if not existlog(log):
			withoutlog = True
			continue
			#return times, primals, primals2, accuracys, accuracys2

		if solver_labels[solver] == 'TRON':
			if type == 'dual':
				continue
			lines = open(log).readlines()
			i = 0
			obj = 0
			#times[solver] = [0]
			while i < len(lines):
				try:
					while i < len(lines) and 'total' not in lines[i]:
						if('iter' in lines[i]):
							if 'fnew' not in lines[i]: 
								obj = float(lines[i].split()[9])
							else:
								obj = float(lines[i].split()[-1])
						i += 1
					i += 4
					if obj == -1 or i >= len(lines):
						break
			
					new_t = float(lines[i-4].split()[-1])
					new_obj = (obj - data.primal) / data.primal
					#if len(times[solver]) > 0 and times[solver][-1] < new_t:
					#		continue
					times[solver]      += [new_t]
					primals[solver]    += [new_obj]
					primals2[solver]   += [obj]
					accuracys[solver]  += [float(lines[i-2].split()[-2])]
					accuracys2[solver] += [float(lines[i-1].split()[-2])]
				except:
					break
			#print primals[solver], times[solver]
		
			#times[solver] = times[solver][0:-1]

			continue


		for line in open(log):
			line = line.strip()
			try:
				if 'total' in line:
					times[solver] += [float(line.split()[-1])]
				elif 'Primal' in line and type == 'primal':
					primals[solver] += [(float(line.split()[-1])-data.primal)/data.primal]
					primals2[solver] += [float(line.split()[-1])]
				elif 'Dual' in line and type == 'dual':
					primals[solver] += [(float(line.split()[-1])+data.primal)/data.primal]
					primals2[solver] += [float(line.split()[-1])]
				elif 'correlation' in line:
					accuracys2[solver] += [float(line.split()[-2])]
				elif 'squared' in line:
					accuracys[solver] += [float(line.split()[-2])]
			except:
				pass


		size = min(len(times[solver]), len(primals[solver]), len(primals2[solver]), len(accuracys[solver]), len(accuracys2[solver]))
		
		step = 1
		if '-sh' not in solver_labels[solver] and '-n' not in solver_labels[solver] and '-nnz' not in solver_labels[solver]:
			#if(size > 200): 
			step = 8

		times[solver]      = times[solver][:size:step]
		primals[solver]    = primals[solver][:size:step]
		primals2[solver]   = primals2[solver][:size:step]
		accuracys[solver]  = accuracys[solver][:size:step]
		accuracys2[solver] = accuracys2[solver][:size:step]
	
		for i in range(1, len(times[solver])):
			if times[solver][i] < times[solver][i-1]:
				times[solver][i]      = times[solver][i-1]
				primals[solver][i]    = primals[solver][i-1]
				primals2[solver][i]   = primals2[solver][i-1]
				accuracys[solver][i]  = accuracys[solver][i-1]
				accuracys2[solver][i] = accuracys2[solver][i-1]

	return times, primals, primals2, accuracys, accuracys2

def draw(drawer, x, y, xlabel, ylabel, filename, p, solver = None, ylim = None, hline = None, hline2 = None, hline3 = None):
	pylab.figure()

	filename = filename.replace('_', '-')

	for i,solver in enumerate(solvers[p]):
		solver_name = solver_labels[solver]
		if solver in rename_solver[p]:
			solver_name = rename_solver[p][solver]
		drawer(x[solver], y[solver], label=solver_name, lw=6, c=solver_color[solver], ls=solver_ls[solver], marker=solver_mark[solver])
	pylab.xlabel(xlabel.replace('_','\_'))
	pylab.ylabel(ylabel.replace('_','\_'))
	pylab.legend(loc='best')

	if ylim: 
		pylab.ylim(ylim)
	if hline:
		pylab.axhline(hline,linestyle='--',color='blue')
	if hline2:
		pylab.axhline(hline2,linestyle='--',color='b')
	if hline3:
		pylab.axhline(hline3,linestyle='-',color='gray')

	if not os.path.exists(figdir):
		os.mkdir(figdir)
	for fmt in FILETYPE:
		pylab.savefig('%s/%s.%s'%(figdir,filename,fmt))

#Draw now!
import matplotlib
matplotlib.use('Agg')
matplotlib.rc('text',usetex=True)
matplotlib.rc('font',family='serif',size='20')
#matplotlib.rc(('xtick.major'), pad = 9)
matplotlib.rc('xtick', labelsize=20)
matplotlib.rc('ytick', labelsize=20)
matplotlib.rc('axes', labelsize=20)
matplotlib.rc('lines', linewidth=4)
from matplotlib import pylab

for p in range(len(solvers)):
	for data in data_sets[p]:
		for type in types:
			if L[p] == 1 and type == 'primal':
				continue
			if L[p] == 2 and type == 'dual' and not show_dual[p]:
				continue

			print(data.name)
		
			if len(solvers[p]) == 0:
				print("Skip. No solver specified.")
				continue

			times, primals, accuracys, accuracys2 = {}, {}, {}, {}

			times, primals, primals2, accuracys, accuracys2 = getcoordinates(data, p, type)


			if withoutlog:
				print('Without enough log to draw figure for %s.' % (data.name))

			old_note = note
			note = names[p]
		
			set_show_lines(show_lines[p])
		
			draw(pylab.loglog, times, primals, 'Time (sec.)', 'Relative function value difference', 'L%s-%s-%s-compare-solvers%s-obj'%(L[p], data.name, type, note), p, hline = get_default_obj(type, data), hline2 = get_default_dcd_obj(type, data), hline3 = get_default_cdn_obj(type, data), ylim = objlimits[p][data])
			#draw(pylab.semilogx, times, primals2, 'Time (sec.)', 'function value', 'L%s-%s-%s-compare-solvers%s-obj2'%(L[p], data.name, type, note), p, ylim = ylimits[data])
			draw(pylab.semilogx, times, accuracys, 'Time (sec.)', 'Means Square Error', 'L%s-%s-%s-compare-solvers%s-err'%(L[p],data.name, type, note), p, hline = get_default_err(data.name), hline2 = get_default_dcd_err(data.name), hline3= get_default_cdn_err(data.name))
			draw(pylab.semilogx, times, accuracys2, 'Time (sec.)', 'Correlation Coefficient', 'L%s-%s-%s-compare-solvers%s-cor'%(L[p],data.name, type, note), p, hline = get_default_cor(data.name), hline2 = get_default_dcd_cor(data.name), hline3 = get_default_cdn_cor(data.name))
			note = old_note
			
