#!/usr/bin/env python

from data import *
from math import *

dataname = ['MSD', 'tfidf6', 'logp6', 
	'dong', 'kddb']
lone_datasets = [MSD_scale_mae_1, E2006_scale_mae_1, LE2006_scale_mae_1, 
		mydong_scale_mae_1, kdd2010b_scale_mae_1]
linear_datasets = [MSD_scale_mae_2, E2006_scale_mae_2, LE2006_scale_mae_2, 
		mydong_scale_mae_2, kdd2010b_scale_mae_2]
ls_datasets = [MSD_scale_lsmae_2, E2006_scale_lsmae_2, LE2006_scale_lsmae_2, 
		mydong_scale_lsmae_2, kdd2010b_scale_lsmae_2]
la_datasets = [MSD_scale_lamae_1, E2006_scale_lamae_1, LE2006_scale_lamae_1, 
		mydong_scale_lamae_1, kdd2010b_scale_lamae_1]

linear_log = 'default-cdn'
ls_log = 'default-cdn'

def _tolog(v):
	v = float(v)
	if v <= 0 or v is None:
		return v
	if v > 1:
		return int(log(v, 2)+0.5)
	else:
		return int(log(v, 2)-0.5)

def tolog(data):
	data.p = '$2^{{{0}}}$'.format(_tolog(data.p))
	data.c = '$2^{{{0}}}$'.format(_tolog(data.c))
	if data.g is not None: data.g = '$2^{{{0}}}$'.format(_tolog(data.g))

for i, data in enumerate(dataname):
	tolog(lone_datasets[i])
	tolog(linear_datasets[i])
	tolog(ls_datasets[i])
	tolog(la_datasets[i])

	lone_mse = -1
	lone_r = -1
	lone_t = -1
	linear_mse = -1
	linear_r = -1
	linear_t = -1
	ls_mse = -1
	ls_r = -1
	ls_t = -1
	la_mse = -1
	la_r = -1
	la_t = -1
	for line in open(linear_log + '/' + lone_datasets[i].name):
		if 'total' in line:
			lone_t = '{0:.0f}'.format(float(line.split()[-1].rstrip('0')))
		elif 'Mean absolute' in line:
			lone_mse = line.split()[-2][:5]
		elif 'Absolute' in line:
			lone_r = line.split()[-2]
	for line in open(linear_log + '/' + linear_datasets[i].name):
		if 'total' in line:
			linear_t = '{0:.0f}'.format(float(line.split()[-1].rstrip('0')))
		elif 'Mean absolute' in line:
			linear_mse = line.split()[-2][:5]
		elif 'Absolute' in line:
			linear_r = line.split()[-2]
	for line in open(ls_log + '/' + ls_datasets[i].name):
		if 'total' in line:
			ls_t = '{0:.0f}'.format(float(line.split()[-1].rstrip('0')))
		elif 'Mean absolute' in line:
			ls_mse = line.split()[-2][:5]
		elif 'Absolute' in line:
			ls_r = line.split()[-2]
	for line in open(linear_log + '/' + la_datasets[i].name):
		if 'total' in line:
			la_t = '{0:.0f}'.format(float(line.split()[-1].rstrip('0')))
		elif 'Mean absolute' in line:
			la_mse = line.split()[-2][:5]
		elif 'Absolute' in line:
			la_r = line.split()[-2]
	
	mses = [lone_mse, la_mse, linear_mse, ls_mse]
	mses = map(float, mses)
	min_mse = min(mses)
	for k in range(len(mses)):
		if mses[k] == min_mse:
			mses[k] = '{{\\bf {0:.03f}}}'.format(mses[k])
		else:
			mses[k] = str(mses[k])

	(lone_mse, la_mse, linear_mse, ls_mse) = mses

	print("\\" + " & ".join(map(str, [dataname[i], lone_datasets[i].p, lone_datasets[i].c, lone_mse, lone_t, la_datasets[i].c, la_mse, la_t, linear_datasets[i].p, linear_datasets[i].c, linear_mse, linear_t, ls_datasets[i].c, ls_mse, ls_t])) + "\\\\")
