#!/usr/bin/env python

import os, sys, time
from data import *
from subprocess import Popen

solvers = [
		[5, 10], #[5, 10, 12], 
		[11, 7], #[11], #[6, 11, 13, 7], 
		[11, 7], #[6, 13, 7], 
		[11, 7],
		]
data_sets = [
		[E2006_scale_default_1, LE2006_scale_default_1, mydong_scale_default_1, kdd2010b_scale_default_1, MSD_scale_default_1],
		[E2006_default_2, LE2006_default_2, mydong_default_2, kdd2010b_default_2, MSD_default_2],
		[E2006_scale_default_2, LE2006_scale_default_2, mydong_scale_default_2, kdd2010b_scale_default_2, MSD_scale_default_2],
		[E2006_scale_lsmse_2, LE2006_scale_lsmse_2, mydong_scale_lsmse_2, kdd2010b_scale_lsmse_2, MSD_scale_lsmse_2],
		]
L = [1, 2, 2, 2]

#data_sets = [cadata]

train = '../liblinear-svr/train'
note = ''
#note = '-nBSV-notime'
#note = '-cdn-shrinking2'
#note = '-cdn-shrinking3'
#note = '-cdn-shrinking4'
#note = '-cdn-shrinking5'
#note = '-cdn-shrinking6'
#note = '-cd-barQ'
cmd = '-e 8 -g 2 -n 32'
force = False
noshrink = False
cptron = False

total_min = 120

for arg in sys.argv[1:]:
	if arg == '-ns':
		train = train + '-ns'
		test = '../svr-tmp5/predict-ns'
		note += '-noshrink'
		noshrink = True
		cmd = '-e 1e-12'
	elif arg == '-f':
		force = True
	elif arg == '-cptron':
		cptron = True
	elif arg[:6] == '-time=':
		total_min = float(arg[6:]) 
	elif arg[:6] == '-note=':
		note = arg[6:]
	elif arg[:6] == '-exec=':
		exec(arg[6:])
	elif arg[:7] == '-train=':
		train = arg[7:]
	else:
		sys.stderr.write('ERROR: no option {0}.\n'.format(arg))
		exit(1)

for p in range(len(solvers)):
	for data in data_sets[p]:
		for solver in solvers[p]:
			print("{0} solver: {1}".format(data.name, solver))
			logname = './log/L{0}-{1}-{2}{3}.log'.format(L[p], data.name, solver, note)

					
			if 'TRON' in solver_labels[solver] and not noshrink and cptron:
				nslogname = './log/L{0}-{1}-{2}-noshrink.log'.format(L[p], data.name, solver)
				if os.path.exists(nslogname):
					os.system('cp {0} {1}'.format(nslogname, logname))
					continue

			if os.path.exists(logname) and not force:
				print("Log exists. Use -f to run all commands.")
				continue
	
			os.system('rm -f {0}'.format(logname))

			fout = open(logname, 'w')

			exec_cmd = '{5} -s {0} {1} -c {6} -p {7} ./data/{2} ./data/{3}'.format(solver, cmd, data.train, data.test, None, train, data.c, data.p)
			print(exec_cmd)
			# os.system(exec_cmd)
			ps = Popen(exec_cmd.split(), shell = False, stdout=fout)

			minutes = 0
			while ps.poll() is None and minutes < total_min:
				time.sleep(60)
				fout.flush()
				minutes += 1

			if ps.poll() is None:
				ps.kill()

			fout.close()

			if 'TRON' in solver_labels[solver] and noshrink and cptron:
				sklogname = './log/L{0}-{1}-{2}.log'.format(L[p], data.name, solver)
				os.system('cp {0} {1}'.format(logname, sklogname))

