#!/usr/bin/env python

import os, sys, time
from data import *
from subprocess import Popen

#E2006_scale_mse_1.c = 128
#E2006_scale_mse_1.g = 8
#LE2006_scale_mse_1.c = 32
#LE2006_scale_mse_1.g = 0.03125

log = 'default-nonlinear'
train   = '../libsvm-3.11-run/svm-train -s 3 -m 16000 -e 0.1'
predict = '../libsvm-3.11-run/svm-predict'
datasets = []
datasets += [MSD_sub_scale_rbfmse_1, mydong_sub_scale_rbfmse_1, kdd2010b_sub_scale_rbfmse_1, E2006_scale_rbfmse_1, LE2006_scale_rbfmse_1]

if not os.path.exists(log):
	os.mkdir(log)

for data in datasets:
	if os.path.exists('{0}/{1}.train'.format(log, data.name)):
		continue

	cmd = '{0} -p {4} -c {5} data/{1} {2}.model > {3}/{2}.train'.format(train, data.train, data.name, log, data.p, data.c)
	if 'g' in dir(data):
		cmd = '{0} -p {4} -g {5} -c {6} data/{1} {2}.model > {3}/{2}.train'.format(train, data.train, data.name, log, data.p, data.g, data.c)
	print(cmd)
	os.system(cmd)
	cmd = '{0} data/{1} {2}.model /dev/null > {3}/{2}.predict'.format(predict, data.test, data.name, log)
	print(cmd)
	os.system(cmd)
